<script setup lang="ts">
////////////////////////////////
// IMPORT
////////////////////////////////

import { useWorkspaceStore } from "@/stores/useWorkspaceStore";
import _ from "lodash";

////////////////////////////////
// PROPS
////////////////////////////////

const props = defineProps({
  workspaceAddMembersDialog: {
    type: Boolean,
    required: true,
  },
});

////////////////////////////////
// EMITS
////////////////////////////////

const emits = defineEmits(["workspaceAddMembersDialog", "newMember"]);

////////////////////////////////
// DATA
////////////////////////////////
const workspaceStore = useWorkspaceStore();
const drawer = ref(false);

const role = ref(null);
const inputUsers = ref([]);
const search = ref(null);
const entries = ref([]);
const isLoading = ref(false);
const newEntries = ref([]);

////////////////////////////////
// WATCH
////////////////////////////////

watch(
  () => props.workspaceAddMembersDialog,
  (newValue) => {
    drawer.value = newValue;
  },
);

watch(inputUsers, () => {
  search.value = "";
});

watch(
  search,
  _.debounce((val) => {
    if (!val || val === "") {
      newEntries.value = [];
      entries.value = newEntries;
      return;
    }

    if (val.length < 3) {
      return;
    }

    isLoading.value = true;

    // Lazily load input items
    workspaceStore
      .searchUser(val)
      .then((res) => {
        newEntries.value = res;
        entries.value = newEntries;
      })
      .finally(() => (isLoading.value = false));
  }, 500),
);

////////////////////////////////
// METHODS
////////////////////////////////

// The `close` method is responsible for closing the dialog by setting the
// `drawer` data property to `false`. It also emits an event called
// "workspaceAddMembersDialog" with a value of `false` to notify the parent
// component that the dialog has been closed.
function close() {
  role.value = null;
  inputUsers.value = [];
  search.value = null;
  entries.value = [];
  isLoading.value = false;
  newEntries.value = [];

  drawer.value = false;
  emits("workspaceAddMembersDialog", false);
}

// The `itemProps` method is used to define the properties of each item
// in the `v-select` component. It takes an `item` as a parameter and returns
// an object with the `title` and `subtitle` properties. These properties are
// used to display the title and subtitle of each item in the dropdown menu of
// the `v-select` component. In this case, the `title` property is set to
// `item.role` and the `subtitle` property is set to `item.description`.
function itemProps(item) {
  return {
    title: item.role,
    subtitle: item.description,
  };
}

// The `getItemTitle` function is defining the title format for each item in the autocomplete dropdown
// menu. It takes an `item` object as a parameter and returns a string that combines the `first_name`,
// `last_name`, and `username` properties of the item. The returned string includes the full name of
// the user (concatenating `first_name` and `last_name`) followed by their username in parentheses. The
// `\n` character is used to create a new line in the string, separating the full name from the
// username for better readability in the dropdown menu.
function getItemTitle(item) {
  return `${item.first_name} ${item.last_name}\n(${item.username})`;
}

// The `getItemValue` function is defining how the value of each item in the autocomplete dropdown menu
// is determined. In this case, the function takes an `item` object as a parameter and returns the `id`
// property of that item as a string. This value is used to uniquely identify each selected item when
// multiple items can be selected in the autocomplete component.
function getItemValue(item) {
  return `${item.id}`;
}

// The `addMember()` method is an asynchronous function that is responsible for
// adding a new member to the current workspace.
async function addMember() {
  let userAdded = 0;
  for (const user of inputUsers.value) {
    await workspaceStore
      .createWorkspaceMember(user.id, role.value?.role)
      .then(() => {
        userAdded++;

        if (userAdded === inputUsers.value.length) {
          emits("newMember", true);
          emits("workspaceAddMembersDialog", false);
        }
      })
      .catch((err) => {
        console.error(err);
      });
  }
  role.value = null;
  inputUsers.value = [];
  entries.value = [];
  newEntries.value = [];
  drawer.value = false;
}
</script>

<template>
  <v-dialog
    v-model="drawer"
    width="50%"
    persistent
  >
    <v-card>
      <v-card-title class="d-flex">
        <v-sheet
          class="me-auto"
          style="
            overflow: hidden;
            white-space: nowrap;
            text-overflow: ellipsis;
            width: calc(100%-30);
          "
        >
          Invite people to <code>{{ workspaceStore.currentWorkspace?.name }}</code>
        </v-sheet>
        <v-sheet>
          <v-btn
            icon="$close"
            density="comfortable"
            variant="plain"
            @click="close"
          />
        </v-sheet>
      </v-card-title>
      <v-card-text>
        <!-- User selection -->
        <v-autocomplete
          v-model="inputUsers"
          v-model:search.sync="search"
          :items="entries.value"
          :loading="isLoading"
          menu-icon=""
          hide-no-data
          hide-selected
          :item-title="getItemTitle"
          :item-value="getItemValue"
          label="Members"
          multiple
          chips
          closable-chips
          return-object
          placeholder="Start typing to Search"
          prepend-icon="mdi-account-multiple-plus-outline"
        >
          <template v-slot:chip="{ props: chipProps, item }">
            <v-chip v-bind="chipProps" :text="`${item.raw.first_name}  ${item.raw.last_name}`" />
          </template>

          <template v-slot:item="{ props: slotProps, item }">
            <v-list-item
              v-bind="slotProps"
              :title="`${item.raw.first_name}  ${item.raw.last_name}`"
              :subtitle="`@${item.raw.username}`"
            />
          </template>
        </v-autocomplete>

        <!-- Role selection -->
        <v-select
          v-model="role"
          :items="Object.values(Object.fromEntries(workspaceStore.workspaceRoles))"
          :item-props="itemProps"
          prepend-icon="mdi-card-account-details-outline"
          label="Role *"
        />

        <div class="d-flex flex-row-reverse">
          <v-btn @click="addMember">
            Add
          </v-btn>
        </div>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>
